--
-- TEST-INC.LUA
--

local a,b,c= 1,2,3
local t= { a=1, b=2, c=3 }

-- Basic testing
--
a += b
print(a)
assert( a==1+2 )
a -= b
print(a)
assert( a==1 )

a *= b
print(a)
assert( a==1*2 )
a /= b
print(a)
assert( a==1 )

-- Table fields
--
t.a += t.b * 3
print(t.a)
assert( t.a==1+(2*3) )
t.a -= t.b * 3
print(t.a)
assert( t.a==1 )

-- More table fields
--
t['a'] += 1
t["a"] += 1
assert( t.a==3 )

t[1]= 0
t[1] += 1
assert( t[1]==1 )

t[t[1]] += 2
assert( t[1]==3 )

t.d= { 5 }
t.d[1] += 2
assert( t.d[1] == 7 )

t.d= { {e=1, 2} }
t.d[1].e += 2
assert( t.d[1].e == 3 )
t.d[1][1] += 5
assert( t.d[1][1] == 7 )

-- Concatenation
--
local s= "wor"
s ..= "k".."s!"
print(s)
assert( s== "works!" )

print "Pass"

--output:
--3
--1
--2
--1
--7
--1
--works!
--Pass
