
-----
-- sample token filter
--
-- Usage:
--      lua -lftools -fnext ...
--
-- Requires:    Lua 5.1, with token filter patch applied
--              ftools.lua
-----

if type( rawget(_G,"FILTER") )~="table" then
    error "requires ftools.lua to be loaded"
end

-------
-- sugar "in <name> do" -> "in next,<name> do"
--
local function NEXT(p)
    p["until"](p,"in")     -- p:until "in"
    local tk,_,tk2= p:peek(2)    -- check next two tokens (but leave insertion place before them)
    if tk=="<name>" and tk2=="do" then
        p:replace( 0, "<name>","next", ',' )     -- to same line as 'tk'
    end
end
FILTER.link( NEXT )
