--
-- TEST_TRICOND.LUA
--

-- This func needed by the token filter
_G["?"]= function( cond )
  return function(tbl)
            assert( tbl, "Usage: ? cond { true_choice, false_choice }" )
            if cond then return tbl[1]
            else         return tbl[2]
            end            
         end  
end


print( assert( ? true { 1,2 } == 1 ) )
print( assert( ? nil { 1,2 } == 2 ) )

print( assert( ? math.pi>3 { 1,2 } == 1 ) )
print( assert( ? math.sqrt(2)>2 { 1,2 } == 2 ) )

print( assert( ? (math.sqrt(2)>2) { 1,2 } == 2 ) )

print( assert( ? true { nil, false } == nil ) )
print( assert( ? true { false, nil } == false ) )

print "Seems ok. :)"
